<template>
  <div class="v-input-number" @mousewheel.stop.prevent="wheelUpdate">
    <btn
      class="v-input-number-btn"
      :class="{ press: pressUp }"
      :disabled="selfValue === max"
      @update="increase"
    >
      <v-icon name="plus" />
    </btn>
    <input
      v-model="selfValue"
      v-number.numeric
      :class="{ pressUp, pressDown }"
      type="tel"
      @blur="checkValue"
    />
    <btn
      class="v-input-number-btn"
      :class="{ press: pressDown }"
      :disabled="selfValue === min"
      @update="decrease"
    >
      <v-icon name="minus" />
    </btn>
  </div>
</template>

<script>
import Btn from './InputNumberBtn'
export default {
  name: 'InputNumber',
  components: { Btn },
  props: {
    value: { type: [Number, String], default: '' },
    max: { type: Number, default: Infinity },
    min: { type: Number, default: -Infinity },
    step: { type: Number, default: 1 }
  },
  data() {
    return {
      selfValue: '',
      pressUp: false,
      pressDown: false,
      pressTimeUpt: false
    }
  },
  watch: {
    value: {
      handler(val) {
        if (val !== this.selfValue) this.selfValue = val * 1
      },
      immediate: true
    },
    selfValue(val, before) {
      if (val !== this.value && val >= this.min && val <= this.max) {
        this.$emit('input', val)
      }

      if (before === undefined) return
      if (before < val) this.pressUp = true
      if (before > val) this.pressDown = true
      window.clearTimeout(this.pressTimeUpt)
      this.pressTimeUpt = window.setTimeout(() => {
        this.pressUp = false
        this.pressDown = false
      }, 100)
    }
  },
  methods: {
    increase() {
      this.selfValue += this.step
    },
    decrease() {
      this.selfValue -= this.step
      this.checkValue()
    },
    wheelUpdate(e) {
      if (e.wheelDeltaY > 0) {
        this.increase()
      } else if (e.wheelDeltaY < 0) {
        this.decrease()
      }
    },
    checkValue() {
      let v = this.selfValue
      if (v < this.min) v = this.min
      if (v > this.max) v = this.max
      this.selfValue = v
    }
  }
}
</script>

<style scoped lang="scss">
@import '../../../assets/sass/variables';
$v-input-number-height: 40px;
.v-input-number {
  color: #757575;
  background-color: #eceaeb;
  border-radius: 5px;
  display: flex;
  input {
    background: none;
    border: none;
    line-height: $v-input-number-height;
    height: $v-input-number-height;
    outline: none;
    flex-grow: 1;
    direction: ltr;
    text-align: center;
    transition: all 0.2s ease;
    color: inherit;
    /*&.pressUp {
      transform: scale(1.1, 1.1);
    }
    &.pressDown {
      transform: scale(0.9, 0.9);
    }*/
  }
  .v-input-number-btn {
    display: block;
    height: $v-input-number-height;
    flex: 0 0 $v-input-number-height;
    padding: 7px;
    cursor: pointer;
    background: none;
    outline: none;
    border: none;
    svg {
      background-color: #a9a9a9;
      color: white;
      border-radius: 50%;
      padding: 5px;
      width: 100%;
      height: 100%;
      transition: all 0.2s ease;
    }
    &:focus svg {
      //box-shadow: 0 0 0 0.2rem rgba($danger, 0.5);
    }
    &.press {
      svg {
        transform: scale(1.2, 1.2);
      }
    }
    &:focus,
    &:active,
    &:hover,
    &.press {
      svg {
        background-color: $danger;
      }
    }
    &:disabled {
      opacity: 0.6;
      cursor: default;
      svg {
        background-color: #a9a9a9;
      }
    }
  }
}
</style>
